﻿﻿////////////////////////////////////////////////////
//定义相关接口参数
// 非对称算法
var ALGID_AUTO = 0;							// 使用证书时自动适配
var ALGID_RSA1024 = 1;						// RSA 1024位算法
var ALGID_RSA2048 = 2;						// RSA 2048位算法
var ALGID_ECC = 3;							// SM2 256位算法

// 摘要算法
var ALGID_HASH_SHA1 = 1;					//SHA-1算法
var ALGID_HASH_SHA256 = 2;  				//SHA-256算法
var ALGID_HASH_SHA512 = 3;  				//SHA-512算法
var ALGID_HASH_MD5 = 4;     				//MD5算法
var ALGID_HASH_MD4 = 5; 					//MD4算法
var ALGID_HASH_SM3 = 6;						//SM3算法

// 证书类型定义
var ENCRYPT_TYPE = 1;						//加密证书
var SIGN_TYPE = 2;							//签名证书

// 证书基本项
var X509_CERT_VERSION =	1;					// 证书版本
var X509_CERT_SERIAL =	2;					// 证书序列号
var X509_CERT_SIGNALG =	3;					// 证书签名算法标识
var X509_CERT_ISSUER_C = 4;					// 证书颁发者国家(C)
var X509_CERT_ISSUER_O = 5;					// 证书颁发者组织名(O)
var X509_CERT_ISSUER_OU = 6;				// 证书颁发者部门名(OU)
var X509_CERT_ISSUER_S = 7;					// 证书颁发者所在的省、自治区、直辖市(S)
var X509_CERT_ISSUER_CN = 8;				// 证书颁发者通用名称(CN)
var X509_CERT_ISSUER_L = 9;					// 证书颁发者所在的城市、地区(L)
var X509_CERT_ISSUER_E = 10;				// 证书颁发者Email
var X509_CERT_NOTBEFORE = 11;				// 证书有效期：起始日期
var X509_CERT_NOTAFTER = 12;				// 证书有效期：终止日期
var X509_CERT_SUBJECT_C = 13;				// 证书拥有者国家(C )
var X509_CERT_SUBJECT_O = 14;				// 证书拥有者组织名(O)
var X509_CERT_SUBJECT_OU = 15;				// 证书拥有者部门名(OU)
var X509_CERT_SUBJECT_S = 16;				// 证书拥有者所在的省、自治区、直辖市(S)
var X509_CERT_SUBJECT_CN = 17;				// 证书拥有者通用名称(CN)
var X509_CERT_SUBJECT_L = 18;				// 证书拥有者所在的城市、地区(L)
var X509_CERT_SUBJECT_E = 19;				// 证书拥有者Email
var X509_CERT_ISSUER_DN = 20;				// 证书颁发者DN
var X509_CERT_SUBJECT_DN = 21;				// 证书拥有者DN
var X509_CERT_DER_PUBKEY = 22;				// 证书公钥信息
var X509_CERT_EXT_CRLDISTRIBUTIONPO = 23;	// CRL发布点
////////////////////////////////////////////////////

// 管理员key类型配置
var ks_provider = ""; // 介质
var ks_alg = ALGID_AUTO;    // 非对称算法，根据证书内容适配
var ks_path = "C:\\CONT\\?";   // 如果为软算法，对应路径
var ks_hash_alg = ALGID_AUTO; // 自动适配算法，RSA时为SHA1, SM2时为SM3

if(IsIE()){
   document.write("<object id=\"SecCtrl\" classid=\"clsid:17F8D3CF-857C-4D7C-9355-7A2398930B6A\" hidden=\"true\" width=\"0\" height=\"0\" codebase=\"downfile\\npSecCtrl.cab#version=1,2,0,0\">");
   document.write("</object>");
}else {
   document.write("<embed id=\"SecCtrl\" type=\"application/npsecctrl-plugin\"  hidden=\"true\" width=\"0\" height=\"0\"/>");
}

function IsIE(){
	//判断是否为IE内核浏览器
	var u = window.navigator.userAgent.toLocaleLowerCase();
	var msie = /(msie) ([\d.]+)/;
	var chrome = /(chrome)\/([\d.]+)/;
	var firefox = /(firefox)\/([\d.]+)/;
	var safari = /(safari)\/([\d.]+)/;
	var opera = /(opera)\/([\d.]+)/;
	var ie11 = /(trident)\/([\d.]+)/;
	b = u.match(msie)||u.match(chrome)||u.match(firefox)||u.match(safari)||u.match(opera)||u.match(ie11);
	if(b[1] == "msie" || b[1] == 'trident'){
		return true;
	}else{
		return false;
	}
}

/**
 * 枚举支持的provider
 * provider: select ID
 */
function EnumProvider(provider){
     while(provider.length > 0){
		provider.remove(0);
	}
	
	var elem3 = document.createElement("option");
    elem3.value = "XACA";
    elem3.text = "自动识别";
    provider.add(elem3);
	 
	var elem1 = document.createElement("option");
	elem1.value = "soft_file";
	elem1.text = "文件证书";
	provider.add(elem1);
	 
	var elem2 = document.createElement("option");
	elem2.value = "SKF&SKFAPI20509.dll";
	elem2.text = "海泰USB KEY";
	provider.add(elem2);

	var elem4 = document.createElement("option");
	elem4.value = "SKF&HNCA3000GM.dll";
	elem4.text = "飞天USB KEY";
	provider.add(elem4);
	 
	var elem5 = document.createElement("option");
	elem5 .value = "HSIC SKF CSP For HD Provider";
	elem5 .text = "化申USB KEY";
	provider.add(elem5);

	if(provider.length > 0){
		provider.selectedIndex = 0;
	}
}

/**
* 获取插KeyVid
*/
function GetDeviceVid() {
    var result = "";
    var lRet = SecCtrl.KS_OpenIE("https://www.baidu.com");
    return result;
}

function GetGetDeviceSerialNumber(){
	var result = "";
	var lRet = SecCtrl.KS_SetProv(ks_provider, ks_alg, ks_path);
	if(lRet != 0){
		alert(SecCtrl.KS_GetLastErrorMsg());
		return result;
	}
	result = SecCtrl.KS_GetAllDeviceSerialNumber();
	if(SecCtrl.KS_GetLastErrorCode() != 0){
		alert(SecCtrl.KS_GetLastErrorMsg());
	}
	return result;
}
/**
 * 初始化函数，设置相关初始值
 * p_provider: 算法提供者
 * p_alg: 非对称算法，1-RSA1024, 2-RSA2048, 3-ECC
 * p_path: 路径
 */
function init(p_provider, p_alg, p_path){
    if(p_provider != null && p_provider != ""){
    	ks_provider = p_provider;
    }
    if(p_alg != null && p_alg != ""){
    	ks_alg = p_alg;
    }
    if(p_path != null && p_path != ""){
    	ks_path = p_path;
    }
}

function openIE(url){
try{
		var lRet = SecCtrl.KS_OpenIE(url);
	}catch(e){
		window.open(url);
	}

}